namespace ETHZ.C0284H.Calculator.CalculatorNode.Visitor
{
    /// <summary>
    /// Visitor interface. Implement this interface to add new kinds of visitors performing additional operations on the node hierarchy
    /// </summary>
    public interface IVisitor
    {
        /// <summary>
        /// Visit an operand
        /// </summary>
        /// <param name="op">
        /// A <see cref="Operand"/>
        /// </param>
        void VisitOperand(Operand op);

        /// <summary>
        /// Visit operator "+"
        /// </summary>
        /// <param name="op">
        /// A <see cref="PlusOperator"/>
        /// </param>
        void VisitPlusOperator(PlusOperator op);

        /// <summary>
        /// Visit operator "-"
        /// </summary>
        /// <param name="opt">
        /// A <see cref="MinusOperator"/>
        /// </param>
        void VisitMinusOperator(MinusOperator opt);

        /// <summary>
        /// Visit operator "*"
        /// </summary>
        /// <param name="op">
        /// A <see cref="TimesOperator"/>
        /// </param>
        void VisitTimesOperator(TimesOperator op);

        /// <summary>
        /// Visit operator "/"
        /// </summary>
        /// <param name="op">
        /// A <see cref="DivideByOperator"/>
        /// </param>
        void VisitDivideByOperator(DivideByOperator op);
    }
}