﻿using ETHZ.C0284H.Calculator.Instruct.Commands;
using ETHZ.C0284H.Calculator.Instruct.Operators;

namespace ETHZ.C0284H.Calculator.Instruct.Visitor
{
    /// <summary>
    /// Instruct visitor interface.
    /// </summary>
    public interface ICalculatorInstructVisitor
    {
        void VisitOperator(PlusInstruct plusOperator);
        void VisitOperator(MinusInstruct minusOperator);
        void VisitOperator(TimesInstruct minusOperator);
        void VisitOperator(DivideByInstruct minusOperator);

        /// <summary>
        /// Visit an operand instruct.
        /// </summary>
        /// <param name="operand">An operand instruct.</param>
        void VisitOperand(CalculatorInstructOperand operand);

        void VisitCommand(LanguageInstruct command);
        void VisitCommand(HelpInstruct command);
        void VisitCommand(ClearInstruct command);
        void VisitCommand(EvaluateInstruct command);
        void VisitCommand(PrintInstruct command);
        void VisitCommand(QuitInstruct command);

        bool InstructProcessed { get; }
    }
}
